﻿package com.nosuch {
	
	public class MidiNoteOn extends MidiChanMsg {
		
		public var pitch:uint;
		public var velocity:uint;

		public function MidiNoteOn(ch:uint, p:uint, v:uint) {
			super(MidiEvent.NOTEON,ch);
			pitch = p;
			velocity = v;
		}
		
		public static function fromXML(xm:XML):MidiNoteOn {
			return new MidiNoteOn(xm.channel,xm.pitch,xm.velocity);
		}
		
		override public function toXML():XML {
			return <midi_noteon channel={channel} pitch={pitch} velocity={velocity}/>;
		}
	}
}
