﻿ package com.nosuch {
 	import flash.events.*;
 	import flash.net.XMLSocket;
 	import flash.utils.*;
 	
 	import flash.net.Socket;

	public class NthPersistentClient extends NthClient {
		
		private static var fingers:Object		= new Object();
		
		private var _timer:Timer;
		private var _myConnected:Boolean = false;
		private var _connections:int = 0;
		private var _attempts:int = 0;
		
		public function NthPersistentClient() {
			configureListeners();
			_tryConnect();
		}
		
		private function _tryConnect():void {
	    	_attempts += 1;
			this.connect("localhost", 1383);
		}
		
	    override public function connectHandler(event:Event):void {
        	_myConnected = true;
        	_connections += 1;
	    }
	    
		override public function closeHandler(event:Event):void {
			trace("NthPersistentClient closehandler called");
			_myConnected = false;
			_scheduleReconnect();
		}
	     
		private function _scheduleReconnect():void {
			// trace("NthClient - scheduling a reconnect");
			_timer = new Timer(1000,1);
			_timer.addEventListener(TimerEvent.TIMER, _tryReconnect);
			_timer.start();
			// super.closeHandler(event);
	    }
	    
		override public function ioErrorHandler(event:IOErrorEvent):void {
	    	if ( ! this._myConnected ) {
				if ( _connections == 0 && _attempts <= 1 ) {
					trace("ioErrorHandler in NthEventClient! e=",event);
				}
	  			_scheduleReconnect();  		
	    	}
		}
	    
	    private function _tryReconnect(event:Event): void {
			_timer.removeEventListener(TimerEvent.TIMER, _tryReconnect);
			_timer.stop();
			_timer = null;
	    	_tryConnect();
	    }
	}
}