﻿package com.nosuch
{
	public class FingerState 
	{
		public var uid:String;
		public var isDown:Boolean;
		public var x:Number;
		public var y:Number;
		public var proximity:Number;
		
		public function FingerState(f:FingerEvent)
		{
			uid = f.fingerUID();
			isDown = (f.type == FingerEvent.DOWN || f.type == FingerEvent.DRAG);
			proximity = f.proximity();
			x = f.x();
			y = f.y();
		}
		public function toString():String {
			return "FingerState(uid="+uid+",isDown="+isDown+",x="+x+",y="+y+",proximity="+proximity+")";
		}
	}
}